package gridslab;

import javax.servlet.http.*;
import org.apache.struts.action.*;

public final class SearchAction extends Action {

  public ActionForward perform(ActionMapping mapping,
                             ActionForm form,
                             HttpServletRequest request,
                             HttpServletResponse response) {

    String[] codes = TestbedManager.getAttributeCodes();
    SearchForm sf = (SearchForm) form; // get the form bean
    // and get the attrib and the value 
    String attribute = sf.getAttribute(); 
    String value = sf.getValue();

    HttpSession session = request.getSession();
    TestbedManager tbm = (TestbedManager)session.getAttribute("tbm");
    if (tbm == null) {
      tbm = new TestbedManager();
      session.setAttribute("tbm", tbm);
    }
/*
 else {
      tbm.updateFromDB();
    }
*/

try {
    int index = Integer.parseInt(attribute);
    tbm.search(codes[index], value);
} catch (NumberFormatException nfe) {
    if (attribute.equalsIgnoreCase("address")) {
      tbm.searchHost(value);
    } else if (attribute.equalsIgnoreCase("loc_country")) {
      tbm.searchCountry(value);
    } else {
      // do the search
      tbm.search(attribute, value);
    }
}

//    request.setAttribute("attribute", attribute);
//    request.setAttribute("value", value);

    // Forward control to the specified success target
    return (mapping.findForward("success"));
  }
}

